//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainFormUnit.h"
#include <inifiles.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"

#include <string>
#include <fstream>
using namespace std;

TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
   : TForm(Owner), str(new TStringList), recent(new TStringList){
   TIniFile *ini;

   ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
   for(int i=0; i<10; i++){
      AnsiString param = "Line"; param+=i;
      recent->Add(ini->ReadString("RecentFiles", param, ""));
   }
   rebuildRecent();

   CPURating->Checked = ini->ReadBool("Checkboxes", "CPURating", false);
   Hits->Checked = ini->ReadBool("Checkboxes", "Hits",      false);
   FoundXXFromYY->Checked = ini->ReadBool("Checkboxes", "FoundXXFromYY", false);
   JobBeginEnd->Checked = ini->ReadBool("Checkboxes", "JobBeginEnd", false);
   BuildFailed->Checked = ini->ReadBool("Checkboxes", "BuildFailed", false);
   Timeouts->Checked = ini->ReadBool("Checkboxes", "Timeouts", false);
   OtherErrors->Checked = ini->ReadBool("Checkboxes", "OtherErrors", false);
   THINKRestart->Checked = ini->ReadBool("Checkboxes", "THINKRestart", false);
   FastRedraw->Checked = ini->ReadBool("Checkboxes", "FastRedraw", false);

   LinesQty->Value = ini->ReadInteger("LinesQty", "Qty", 500);

   delete ini;
   if(RecentFiles1->Count)
      RecentFileExecute(RecentFiles1->Items[0]);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileExitExecute(TObject *Sender){
   Close();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileOpenExecute(TObject *Sender){
   if(!OpenDialog->Execute())return;
   if(recent->Count > 9)
      recent->Delete(recent->Count);
   recent->Insert(0, OpenDialog->FileName);
   rebuildRecent();

//   str->Clear();
//   try{
//      str->LoadFromFile(OpenDialog->FileName);
//   }catch(...){
//      ShowMessage(AnsiString("Cannot open file: ") + OpenDialog->FileName);
//   }
   readLogfile(OpenDialog->FileName);

   MainForm->Caption = AnsiString("ShowLog v.0.91beta -- ") + OpenDialog->FileName;
   RedrawMemoExecute(this);
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::RecentFileExecute(TObject *Sender){
   TMenuItem* sender = dynamic_cast<TMenuItem*>(Sender);
   AnsiString filename = sender->Caption;
   if(recent->Count > 9)
      recent->Delete(recent->Count);
   recent->Insert(0, filename);
   rebuildRecent();

//   str->Clear();
//   try{
//      str->LoadFromFile(filename);
//   }catch(...){
//      ShowMessage(AnsiString("Cannot open file: ") + filename);
//   }
   readLogfile(filename);

   MainForm->Caption = AnsiString("ShowLog v.0.91beta -- ") + filename;
   RedrawMemoExecute(this);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action){
   TIniFile *ini;
   ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
   for(int i=0; i<recent->Count; i++){
      AnsiString param = "Line"; param+=i;
      ini->WriteString("RecentFiles", param, recent->Strings[i]);
   }

   ini->WriteBool("Checkboxes", "CPURating", CPURating->Checked);
   ini->WriteBool("Checkboxes", "Hits", Hits->Checked);
   ini->WriteBool("Checkboxes", "FoundXXFromYY", FoundXXFromYY->Checked);
   ini->WriteBool("Checkboxes", "JobBeginEnd", JobBeginEnd->Checked);
   ini->WriteBool("Checkboxes", "BuildFailed", BuildFailed->Checked);
   ini->WriteBool("Checkboxes", "Timeouts", Timeouts->Checked);
   ini->WriteBool("Checkboxes", "OtherErrors", OtherErrors->Checked);
   ini->WriteBool("Checkboxes", "THINKRestart", THINKRestart->Checked);
   ini->WriteBool("Checkboxes", "FastRedraw", FastRedraw->Checked);

   ini->WriteInteger("LinesQty", "Qty", LinesQty->Value);

   delete ini;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RedrawMemoExecute(TObject *Sender){
   int start = str->Count - LinesQty->Value;
   if(start<0) start = 0;
   Memo1->Clear();
   if(FastRedraw->Checked) Memo1->Visible = false;
   for(int i=start; i < str->Count; i++){
      if(AnsiPos("CPU rating :", str->Strings[i]) && CPURating->Checked) continue;
      if(AnsiPos("Found", str->Strings[i]) && AnsiPos(":", str->Strings[i]) && Hits->Checked) continue;
      if(AnsiPos("Found", str->Strings[i]) && AnsiPos("from", str->Strings[i]) && FoundXXFromYY->Checked) continue;
      if((AnsiPos("Completed :", str->Strings[i]) || AnsiPos("Starting :", str->Strings[i])) && JobBeginEnd->Checked) continue;
      if(AnsiPos("3D build failed", str->Strings[i]) && BuildFailed->Checked) continue;
      if(AnsiPos("Conformational generation time", str->Strings[i]) && Timeouts->Checked) continue;
      if((AnsiPos("Too many rotable bonds", str->Strings[i]) || AnsiPos("Fit fails", str->Strings[i]) || AnsiPos("Waiting", str->Strings[i]) || AnsiPos("(13) Unformatted file", str->Strings[i]) || AnsiPos("(28) End of file: screen.ini", str->Strings[i]) || AnsiPos("(49) Command text missing", str->Strings[i]) || AnsiPos("(134) End of file", str->Strings[i]) ) && OtherErrors->Checked) continue;
      if((AnsiPos("CALL THINK_EXEC:screen.ini", str->Strings[i]) || AnsiPos("Starting client on", str->Strings[i]) || AnsiPos("Continuing :", str->Strings[i])) && THINKRestart->Checked) continue;
      Memo1->Lines->Add(str->Strings[i]);
   }
   Memo1->Visible = true;
   Memo1->Lines->Add("");
}
//---------------------------------------------------------------------------
void TMainForm::rebuildRecent(){
   for(int i=0; i < recent->Count; i++)
      for(int j = i+1; j < recent->Count; j++)
         if(recent->Strings[i]==recent->Strings[j])
            recent->Delete(j);
   RecentFiles1->Clear();
   for(int i=0; i < recent->Count && recent->Strings[i].Length(); i++)
         RecentFiles1->Add(NewItem(recent->Strings[i], 0, false, true,
                           RecentFile->OnExecute, 0, ""));
}
//---------------------------------------------------------------------------

void TMainForm::readLogfile(AnsiString filename){
   str->Clear();
   ifstream file(filename.c_str());

   if(!file){
      ShowMessage(AnsiString("Cannot open file: ") + filename);
      return;
   }

   string tmp;
   while(file){
      getline(file, tmp);
      str->Add(AnsiString(tmp.data()));
   }
}
